UnavailableException (Servlet 6.1 API Documentation - Apache Tomcat 11.0.24)
Description: declaration: package: jakarta.servlet, class: UnavailableException

# Class UnavailableException

java.lang.Object
java.lang.Throwable
java.lang.Exception
jakarta.servlet.ServletException
jakarta.servlet.UnavailableException

All Implemented Interfaces:
  `Serializable`

public class UnavailableException extends ServletException
Defines an exception that a servlet or filter throws to indicate that it is permanently or temporarily unavailable.

When a servlet or filter is permanently unavailable, something is wrong with it, and it cannot handle requests until some action is taken. For example, a servlet might be configured incorrectly, or a filter's state may be corrupted. The component should log both the error and the corrective action that is needed.

A servlet or filter is temporarily unavailable if it cannot handle requests momentarily due to some system-wide problem. For example, a third-tier server might not be accessible, or there may be insufficient memory or disk storage to handle requests. A system administrator may need to take corrective action.

Servlet containers can safely treat both types of unavailable exceptions in the same way. However, treating temporary unavailability effectively makes the servlet container more robust. Specifically, the servlet container might block requests to the servlet or filter for a period of time suggested by the exception, rather than rejecting them until the servlet container restarts.

See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `UnavailableException(String msg)`
  Constructs a new exception with a descriptive message indicating that the servlet is permanently unavailable.
  `UnavailableException(String msg, int seconds)`
  Constructs a new exception with a descriptive message indicating that the servlet is temporarily unavailable and giving an estimate of how long it will be unavailable.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getUnavailableSeconds()`
  Returns the number of seconds the servlet expects to be temporarily unavailable.
  `boolean`
  `isPermanent()`
  Returns a `boolean` indicating whether the servlet is permanently unavailable.

  ### Methods inherited from class ServletException

  `getRootCause`

  ### Methods inherited from class Throwable

  `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### UnavailableException

    public UnavailableException(String msg)
    Constructs a new exception with a descriptive message indicating that the servlet is permanently unavailable.
    Parameters:
      `msg` - a `String` specifying the descriptive message

  - ### UnavailableException

    public UnavailableException(String msg, int seconds)
    Constructs a new exception with a descriptive message indicating that the servlet is temporarily unavailable and giving an estimate of how long it will be unavailable.

    In some cases, the servlet cannot make an estimate. For example, the servlet might know that a server it needs is not running, but not be able to report how long it will take to be restored to functionality. This can be indicated with a negative or zero value for the `seconds` argument.

    Parameters:
      `msg` - a `String` specifying the descriptive message, which can be written to a log file or displayed for the user.
      `seconds` - an integer specifying the number of seconds the servlet expects to be unavailable; if zero or negative, indicates that the servlet can't make an estimate

- ## Method Details

  - ### isPermanent

    public boolean isPermanent()
    Returns a `boolean` indicating whether the servlet is permanently unavailable. If so, something is wrong with the servlet, and the system administrator must take some corrective action.
    Returns:
      `true` if the servlet is permanently unavailable; `false` if the servlet is available or temporarily unavailable

  - ### getUnavailableSeconds

    public int getUnavailableSeconds()
    Returns the number of seconds the servlet expects to be temporarily unavailable.

    If this method returns a negative number, the servlet is permanently unavailable or cannot provide an estimate of how long it will be unavailable. No effort is made to correct for the time elapsed since the exception was first reported.

    Returns:
      an integer specifying the number of seconds the servlet will be temporarily unavailable, or a negative number if the servlet is permanently unavailable or cannot make an estimate